set echo on
connect / as sysdba
pause
alter session set container=pdborcl;
pause
create or replace directory share_dir
  as '/u01/app/oracle/admin/orcl/share';
pause
create or replace directory noaa_dir
  as '/u01/app/oracle/admin/orcl/share/noaa';
pause
create or replace directory noaa_1901_dir
  as '/u01/app/oracle/admin/orcl/share/noaa_1901'; 
pause
create or replace directory noaa_1902_dir
  as '/u01/app/oracle/admin/orcl/share/noaa_1902'; 
pause
create or replace directory noaa_1903_dir
  as '/u01/app/oracle/admin/orcl/share/noaa_1903'; 
pause
create or replace directory noaa_1904_dir
  as '/u01/app/oracle/admin/orcl/share/noaa_1904'; 
pause
grant all on directory share_dir to public;
pause
grant all on directory noaa_dir to public;
pause
grant all on directory noaa_1901_dir to public;
pause
grant all on directory noaa_1902_dir to public;
pause
grant all on directory noaa_1903_dir to public;
pause
grant all on directory noaa_1904_dir to public;
pause
connect iggy/iggy@pdborcl
pause
drop table temperatures;
create table temperatures
(
  station_code char(6),
  datetime char(12),
  temperature char(5)
)
organization external
(
  type oracle_loader
  default directory share_dir
  access parameters
  (
    records delimited by newline
    preprocessor share_dir:'uncompress.sh'
    fields
    (
      station_code position(1:6) char(4),
      datetime position(7:18) char(12),
      temperature position(19:23) char(5)
    )
  )
  location ('noaa')
);
pause
set pagesize 66
select /*+ gather_plan_statistics */ * from
(
  select
    month,
    station_code,
    dense_rank() over (partition by month order by average) as rank
  from
  (
    select
      substr(datetime,1,4)||'/'||substr(datetime,5,2) as month,
      station_code,
      avg(temperature) as average
    from temperatures
    where datetime >= '1901' and datetime < '1902'
    group by
      substr(datetime,1,4)||'/'||substr(datetime,5,2),
      station_code
  )
)
pivot(max(station_code) for rank in (1, 2, 3))
order by month;
pause
set linesize 200
select * from table(dbms_xplan.display_cursor(null, null, 'TYPICAL IOSTATS LAST'));
pause
drop table temperatures_1901;
create table temperatures_1901
(
  station_code char(6),
  datetime char(12),
  temperature char(5)
)
organization external
(
  type oracle_loader
  default directory noaa_dir
  access parameters
  (
    records delimited by newline
    preprocessor share_dir:'uncompress.sh'
    fields
    (
      station_code position(1:6) char(4),
      datetime position(7:18) char(12),
      temperature position(19:23) char(5)
    )
  )
  location ('1901')
);
pause
drop table temperatures_1902;
create table temperatures_1902
(
  station_code char(6),
  datetime char(12),
  temperature char(5)
)
organization external
(
  type oracle_loader
  default directory noaa_dir
  access parameters
  (
    records delimited by newline
    preprocessor share_dir:'uncompress.sh'
    fields
    (
      station_code position(1:6) char(4),
      datetime position(7:18) char(12),
      temperature position(19:23) char(5)
    )
  )
  location ('1902')
);
pause
drop table temperatures_1903;
create table temperatures_1903
(
  station_code char(6),
  datetime char(12),
  temperature char(5)
)
organization external
(
  type oracle_loader
  default directory noaa_dir
  access parameters
  (
    records delimited by newline
    preprocessor share_dir:'uncompress.sh'
    fields
    (
      station_code position(1:6) char(4),
      datetime position(7:18) char(12),
      temperature position(19:23) char(5)
    )
  )
  location ('1903')
);
pause
drop table temperatures_1904;
create table temperatures_1904
(
  station_code char(6),
  datetime char(12),
  temperature char(5)
)
organization external
(
  type oracle_loader
  default directory noaa_dir
  access parameters
  (
    records delimited by newline
    preprocessor share_dir:'uncompress.sh'
    fields
    (
      station_code position(1:6) char(4),
      datetime position(7:18) char(12),
      temperature position(19:23) char(5)
    )
  )
  location ('1904')
);
pause
create or replace view temperatures_v as
select * from temperatures_1901
where datetime >= '190101010000' and datetime < '190201010000'
  union all
select * from temperatures_1902
where datetime >= '190201010000' and datetime < '190301010000'
  union all
select * from temperatures_1903
where datetime >= '190301010000' and datetime < '190401010000'
  union all
select * from temperatures_1904
where datetime >= '190401010000' and datetime < '190501010000';
pause
select /*+ gather_plan_statistics */ * from
(
  select
    month,
    station_code,
    dense_rank() over (partition by month order by average) as rank
  from
  (
    select
      substr(datetime,1,4)||'/'||substr(datetime,5,2) as month,
      station_code,
      avg(temperature) as average
    from temperatures_v
    where datetime >= '190101010000' and datetime < '190201010000'
    group by
      substr(datetime,1,4)||'/'||substr(datetime,5,2),
      station_code
  )
)
pivot(max(station_code) for rank in (1, 2, 3))
order by month;
pause
select * from table(dbms_xplan.display_cursor(null, null, 'TYPICAL IOSTATS LAST'));
pause
select /*+ gather_plan_statistics */ * from
(
  select
    month,
    station_code,
    dense_rank() over (partition by month order by average) as rank
  from
  (
    select
      substr(datetime,1,4)||'/'||substr(datetime,5,2) as month,
      station_code,
      avg(temperature) as average
    from temperatures_v
    where datetime >= '190501010000' and datetime < '190601010000'
    group by
      substr(datetime,1,4)||'/'||substr(datetime,5,2),
      station_code
  )
)
pivot(max(station_code) for rank in (1, 2, 3))
order by month;
pause
select * from table(dbms_xplan.display_cursor(null, null, 'TYPICAL IOSTATS LAST'));
pause
alter table temperatures_1901 parallel 2;
pause
select /*+ gather_plan_statistics */ * from
(
  select
    month,
    station_code,
    dense_rank() over (partition by month order by average) as rank
  from
  (
    select
      substr(datetime,1,4)||'/'||substr(datetime,5,2) as month,
      station_code,
      avg(temperature) as average
    from temperatures_v
    where datetime >= '190101010000' and datetime < '190501010000'
    group by
      substr(datetime,1,4)||'/'||substr(datetime,5,2),
      station_code
  )
)
pivot(max(station_code) for rank in (1, 2, 3))
order by month;
select * from table(dbms_xplan.display_cursor(null, null, 'TYPICAL IOSTATS'));
pause
exit